#ifndef __VUMANAGER_H__
#define __VUMANAGER_H__

#include "singleton.h"
#include "dma.h"

#define VUManager CVUManager::GetSingleton()

class CVUManager;

class CVU1MicroProgram
{
	friend CVUManager;

public:
	CVU1MicroProgram(uint64 * pCode, uint64 * pCodeEnd, int Offset = 0);
	~CVU1MicroProgram();

	void Upload();	// Send the program to VU1 memory
	void Call();
	void Cnt();

private:
	int m_iOffset;
	int m_pUploadPtr;
};

inline void CVU1MicroProgram::Call()
{
	VIFDynamicDMA.Add32(MSCALL(m_iOffset));
}

class CVUManager : public CSingleton<CVUManager>
{
public:
	CVUManager();
	~CVUManager();

private:
	CVU1MicroProgram * m_pMPGs;
};

#endif